uses
  testlib, SysUtils;

const
  MAX = 50;

var
  n, m, i, j, v, d: integer;
  x, y: array[1..MAX * MAX] of integer;

begin
  fillchar(x, sizeof(x), 0);
  fillchar(y, sizeof(y), 0);
  n := inf.readlongint;
  m := inf.readlongint;
  for i := 1 to n do
  begin
    for j := 1 to m do
    begin
      v := ouf.readlongint;
      if (v < 1) or (v > n * m) then
        quit(_wa, 'Invalid number: ' + inttostr(v));
      if (x[v] <> 0) then
        quit(_wa, 'Duplicate: ' + inttostr(v));
      x[v] := i;
      y[v] := j;
    end;
  end;
  for i := 1 to n * m - 1 do
  begin
    d := abs(x[i] - x[i + 1]) + abs(y[i] - y[i + 1]);
    if (d > 1) then
      quit(_wa, 'Numbers ' + inttostr(i) + ' and ' + inttostr(i + 1) + ' are not neighbours');
  end;

  quit(_ok, inttostr(n) + '*' + inttostr(m));
end.